JSB.newAddon = function(mainPath) {
    var baseUrl =function (name,note) {
         Name="name="+name;
         Note="&note="+note;
         UrlHead="omnifocus:///add?";
let omniurl =UrlHead+Name+Note;
return omniurl;
};
    //MARK: - Customized functions
    // URL generation
    // Open Omnifocus
    function openUrlWithExternalBrowser(url) {
        // endoce URL to utf-8. NSURL cannot handle Chinese url
        let encodedUrl = encodeURI(url);
        UIApplication.sharedApplication().openURL(NSURL.URLWithString(encodedUrl));
    }
    //MARK - Addon Class definition
    var newAddonClass= JSB.defineClass('OmnifocusPlugIn : JSExtension', {
        //Mark: - Instance Method Definitions
        // Window initialize
        sceneWillConnect: function() {
         self.webController = WebViewController.new();
        },
        // Window disconnect
        sceneDidDisconnect: function() {
        },
        // Window resign active
        sceneWillResignActive: function() {
        },
        // Window become active
        sceneDidBecomeActive: function() {
        },
        //MARK: MN behaviors
        notebookWillOpen: function(notebookid) {
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnNote:', 'PopupMenuOnNote');
            
            self.OmnifocusPlugInIsOn = NSUserDefaults.standardUserDefaults().objectForKey('marginnote_OmnifocusPlugIn');
        },
        notebookWillClose: function(notebookid) {
                      NSNotificationCenter.defaultCenter().removeObserverName(self, 'PopupMenuOnNote');
        },
        documentDidOpen: function(docmd5) {
        },
        docmentWillClose: function(docmd5) {
        },
        controllerWillLayoutSubviews: function(controller) {
        },
        queryAddonCommandStatus: function() {
            if(Application.sharedInstance().studyController(self.window).studyMode < 3) {
                return {
                    image: 'OmnifocusPlugIn.png',
                    object: self,
                    selector: "toggleOmnifocusPlugIn:",
                    checked: self.OmnifocusPlugInIsOn
                };
            }
            return null;
        },

        // Select text and open the external Browser to process the selected Text
        onPopupMenuOnNote: function (sender) {
            if (!Application.sharedInstance().checkNotifySenderInWindow(sender, self.window)) return;//Don't process message from other window
            if (!self.OmnifocusPlugInIsOn) return;
            let note = sender.userInfo.note;
            let titleText = note.noteTitle;
            let excerptText = note.excerptText.replace(/\*\*/g, '');
            let text1 = titleText || excerptText;
            let text2 = "！";
            let text3 = note.noteId;
            let text4 = "marginnote3app://note/"+text3;
            let text = text1 + text2 +text3;
            if (text && text.length) {
                // Copy to Clipboard
                let pasteBoard = UIPasteboard.generalPasteboard();
                pasteBoard.string = text;
                let url = baseUrl(text1,text4);
                openUrlWithExternalBrowser(url);
            }
},
        // Add-On Switch
        toggleOmnifocusPlugIn: function(sender) {
            var lan = NSLocale.preferredLanguages().length ? NSLocale.preferredLanguages()[0].substring(0, 2) : 'en';
            let tips = lan === 'zh' ? 'Omnifocus插件已关闭' : 'OmnifocusPlugIn is off';
            if(self.OmnifocusPlugInIsOn) {
                self.OmnifocusPlugInIsOn = false;
            } else {
                self.OmnifocusPlugInIsOn = true;
                tips = lan === 'zh' ? 'Omnifocus插件已开启，任务将自动添加' : 'The OmnifocusPlugIn is turned on and the task will be added automatically.';
            }
            Application.sharedInstance().showHUD(tips, self.window, 2);
            NSUserDefaults.standardUserDefaults().setObjectForKey(self.OmnifocusPlugInIsOn, 'marginnote_OmnifocusPlugIn');
            Application.sharedInstance().studyController(self.window).refreshAddonCommands();
        },
    }, {
        //MARK: - Class Method Definitions
        addonDidConnect: function() {
        },
        addonWillDisconnect: function() {
        },
        applicationWillEnterForeground: function() {
        },
        applicationDidEnterBackground: function() {
        z},
        applicationDidReceiveLocalNotification: function(notify) {
        },
    });
    return newAddonClass;
};
